## lomiri-tfamanager-app 1.7.3+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
project(tfamanager VERSION 1.7.3 LANGUAGES C CXX)

# Automatically create moc files
set(CMAKE_AUTOMOC ON)

# Components PATH
execute_process(
    COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
    OUTPUT_VARIABLE ARCH_TRIPLET
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

option(CLICK_MODE "Installs to a contained location" ON)

# Standard install paths
include(GNUInstallDirs)

set(APP_NAME             "2FA Manager")
set(APP_VERSION          "${PROJECT_VERSION}")
set(FULL_PROJECT_NAME    "tfamanager.cibersheep")
set(ICON_FILE            "logo.svg")
set(SPLASH_FILE          "splash.svg")

if(CLICK_MODE)
    set(CMAKE_INSTALL_PREFIX /)

    set(APP_HARDCODE     "tfamanager")
    set(QT_IMPORTS_DIR   "lib/${ARCH_TRIPLET}")
    set(DATA_DIR         ".")
    set(ICON             "${DATA_DIR}/assets/${ICON_FILE}")
    set(SPLASH           "${DATA_DIR}/assets/${SPLASH_FILE}")
    set(DESKTOP_DIR      "${DATA_DIR}")
    set(URLS_DIR         "${DATA_DIR}")
    set(CONTENTHUB_DIR   "${DATA_DIR}")
    set(LOCALE_DIR       "${DATA_DIR}/share/locale")
    set(EXEC             "qmlscene %U qml/Main.qml")

    install(FILES ${PROJECT_NAME}.apparmor
            DESTINATION ${DATA_DIR})
    install(FILES ${PROJECT_NAME}-dispatcher.json
            DESTINATION ${URLS_DIR})
    install(FILES ${PROJECT_NAME}-contenthub.json
            DESTINATION ${CONTENTHUB_DIR})

else(CLICK_MODE)
    set(APP_HARDCODE     "lomiri-tfamanager-app")
    set(QT_IMPORTS_DIR   "${CMAKE_INSTALL_FULL_LIBDIR}/qt5/qml")
    set(DATA_DIR         "${CMAKE_INSTALL_FULL_DATADIR}/${APP_HARDCODE}")
    set(ICON             "${DATA_DIR}/assets/${ICON_FILE}")
    set(SPLASH           "${DATA_DIR}/assets/${SPLASH_FILE}")
    set(DESKTOP_DIR      "${CMAKE_INSTALL_FULL_DATADIR}/applications")
    set(URLS_DIR         "${CMAKE_INSTALL_FULL_DATADIR}/lomiri-url-dispatcher/urls")
    set(CONTENTHUB_DIR   "${CMAKE_INSTALL_FULL_DATADIR}/lomiri-content-hub/peers/")
    set(LOCALE_DIR       "${CMAKE_INSTALL_FULL_LOCALEDIR}")
    set(EXEC             "qmlscene %U ${DATA_DIR}/qml/Main.qml")

#    install(FILES ${PROJECT_NAME}.apparmor
#            RENAME ${APP_HARDCODE}.apparmor
#            DESTINATION ${DATA_DIR})
    install(FILES ${PROJECT_NAME}-dispatcher.json
            RENAME ${APP_HARDCODE}
            DESTINATION ${URLS_DIR})
    install(FILES ${PROJECT_NAME}-contenthub.json
            RENAME ${APP_HARDCODE}
            DESTINATION ${CONTENTHUB_DIR})
endif(CLICK_MODE)

set(DESKTOP_FILE_NAME_IN "${PROJECT_NAME}.desktop")
set(DESKTOP_FILE_NAME    "${APP_HARDCODE}.desktop")

# This command figures out the minimum SDK framework for use in the manifest
# file via the environment variable provided by Clickable or sets a default value otherwise.
if(DEFINED ENV{SDK_FRAMEWORK})
    set(CLICK_FRAMEWORK  "$ENV{SDK_FRAMEWORK}")
else()
    set(CLICK_FRAMEWORK  "ubuntu-sdk-20.04")
endif()

# This figures out the target architecture for use in the manifest file.
if(DEFINED ENV{ARCH})
    set(CLICK_ARCH       "$ENV{ARCH}")
else()
    execute_process(
        COMMAND dpkg-architecture -qDEB_HOST_ARCH
        OUTPUT_VARIABLE CLICK_ARCH
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif()

if(CLICK_MODE)
configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${DATA_DIR})
endif()
configure_file(About.qml.in ${CMAKE_CURRENT_BINARY_DIR}/About.qml)
install(DIRECTORY qml DESTINATION ${DATA_DIR}
   #Exclude the non-minified otpauth lib file
    PATTERN "otpauth.js" EXCLUDE)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/About.qml DESTINATION ${DATA_DIR}/qml)
install(DIRECTORY assets DESTINATION ${DATA_DIR})

# Replace CMake variables in .desktop.in.in file with proper values.
configure_file(${DESKTOP_FILE_NAME_IN}.in.in ${DESKTOP_FILE_NAME_IN}.in)

# Translations
file(GLOB_RECURSE I18N_SRC_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/po qml/*.qml qml/*.js About.qml.in)
# We could also remove the js filter from above, but like this might be more clear for other developers
list(REMOVE_ITEM I18N_SRC_FILES PATTERN "otpauth" EXCLUDE)
list(APPEND I18N_SRC_FILES ${DESKTOP_FILE_NAME_IN}.in.h)

find_program(INTLTOOL_MERGE intltool-merge)
if(NOT INTLTOOL_MERGE)
    message(FATAL_ERROR "Could not find intltool-merge, please install the intltool package")
endif()
find_program(INTLTOOL_EXTRACT intltool-extract)
if(NOT INTLTOOL_EXTRACT)
    message(FATAL_ERROR "Could not find intltool-extract, please install the intltool package")
endif()

add_custom_target(${DESKTOP_FILE_NAME} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE_NAME}..."
    COMMAND LC_ALL=C ${INTLTOOL_MERGE} -d -u ${CMAKE_SOURCE_DIR}/po ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_NAME_IN}.in ${DESKTOP_FILE_NAME}
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_NAME} DESTINATION ${DESKTOP_DIR})

add_subdirectory(po)

# Make source files visible in qtcreator
file(GLOB_RECURSE PROJECT_SRC_FILES
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    qml/*.qml
    qml/*.js
    *.json
    *.json.in
    *.apparmor
    *.desktop.in
)

add_custom_target(${APP_HARDCODE}_FILES ALL SOURCES ${PROJECT_SRC_FILES})

=== po/CMakeLists.txt ===
include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${FULL_PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

# Creates the .pot file containing the translations template
add_custom_target(${POT_FILE} ALL
    COMMENT "Generating translation template"
    COMMAND ${INTLTOOL_EXTRACT} --update --type=gettext/ini
        --srcdir=${CMAKE_BINARY_DIR} ${DESKTOP_FILE_NAME_IN}.in

    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
        -D ${CMAKE_CURRENT_SOURCE_DIR}
        -D ${CMAKE_CURRENT_BINARY_DIR}
        --from-code=UTF-8
        --c++ --qt --language=javascript --add-comments=TRANSLATORS
        --keyword=tr --keyword=tr:1,2 --keyword=N_ --keyword=_
        --package-name='${DOMAIN}'
         --copyright-holder='Joan CiberSheep'
         --msgid-bugs-address=info@cibersheep.com
        ${I18N_SRC_FILES}

    #Replace default copyright
	COMMAND sed -i 's/\# SOME DESCRIPTIVE TITLE./\# This file is part of the 2FA Manager App for Ubuntu Touch/' ${POT_FILE}
	COMMAND sed -i 's/\# Copyright \(C\) YEAR/\# Copyright \(C\) 2019/' ${POT_FILE}
	COMMAND sed -i 's/\# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR./\# Joan CiberSheep <info@cibersheep.com> \(C\) 2019/' ${POT_FILE}

    COMMAND ${CMAKE_COMMAND} -E copy ${POT_FILE} ${CMAKE_CURRENT_SOURCE_DIR})

# Builds the binary translations catalog for each language
# it finds source translations (*.po) for
foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${LOCALE_DIR}/${LANG}/LC_MESSAGES)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
            DESTINATION ${INSTALL_DIR}
            RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== debian/changelog ===
lomiri-tfamanager-app (1.7.3+dfsg-5) unstable; urgency=medium

  * debian/patches:
    + Add 1001_CMake-4.patch. Support building with CMake 4. (Closes: #1113248).
  * debian/control:
    + Add to D: lomiri-app-launch-tools.
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/bin/lomiri-tfamanager-app:
    + Use lomiri-app-launch cmdline wrapper to launch the app.
  * debian/copyright:
    + Update FSF mailing address.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 02 Sep 2025 16:24:57 +0200

lomiri-tfamanager-app (1.7.3+dfsg-4) unstable; urgency=medium

  * debian/patches:
    + Update/fix 2001_use-non-minified-otpauth-js.patch. Don't exclude
      otpauth.js file in CMakeLists.txt.
  * debian/rules:
    + Backup and restore po/tfamanager.cibersheep.pot before and after build
      (to support rebuilding the package after build).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 11 Feb 2025 10:31:57 +0100

lomiri-tfamanager-app (1.7.3+dfsg-3) unstable; urgency=medium

  * debian/patches:
    + Update 2001_use-non-minified-otpauth-js.patch. Also adjust Main.qml to
      use the non-minifid otpauth.js file.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 10 Feb 2025 14:23:52 +0100

lomiri-tfamanager-app (1.7.3+dfsg-2) unstable; urgency=medium

  * Re-upload source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 18 Jan 2025 17:54:02 +0100

lomiri-tfamanager-app (1.7.3+dfsg-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1087376).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 14 Jan 2025 17:03:00 +0100

=== debian/control ===
Source: lomiri-tfamanager-app
Priority: optional
Section: misc
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               intltool,
               qtbase5-dev,
               qtdeclarative5-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/cibersheep/tfamanager
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-tfamanager-app.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-tfamanager-app

Package: lomiri-tfamanager-app
Architecture: all
Depends: lomiri-app-launch-tools,
         qmlscene,
         qml-module-qtquick2,
         qml-module-lomiri-components,
         qml-module-lomiri-content,
         ${misc:Depends}
Description: 2-Factor-Authentication Manager App for Lomiri Operating Environment
 This app is a core app for Ubuntu Touch's shell Lomiri. Ubuntu Touch is
 a mobile OS developed by the UBports Foundation. Lomiri is its operating
 environment optimized for touch based human-machine interaction, but
 also supports convergence (i.e. switching between tablet/phone and
 desktop mode).
 .
 This package provides a 2FA Manager App for Lomiri.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	if [ ! -e po/tfamanager.cibersheep.pot.deb-bak ]; then cp po/tfamanager.cibersheep.pot po/tfamanager.cibersheep.pot.deb-bak; fi
	dh_auto_configure -- -DCLICK_MODE=OFF

override_dh_install:
	dh_install
	mkdir -p debian/lomiri-tfamanager-app/usr/bin/
	cp debian/bin/lomiri-tfamanager-app debian/lomiri-tfamanager-app/usr/bin/

override_dh_clean:
	dh_clean
	if [ -e po/tfamanager.cibersheep.pot.deb-bak ]; then mv po/tfamanager.cibersheep.pot.deb-bak po/tfamanager.cibersheep.pot; fi

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
opts="searchmode=plain, repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/cibersheep/tfamanager/tags?sort=updated_desc -/archive/v?\d[\d.]+/tfamanager-@ANY_VERSION@@ARCHIVE_EXT@
